变量:命名的内存空间  
数据存储方式:            
    字符:            
    数值:整型,浮点型 

变量:变量类型  
    作用:   
        1、数据存储格式   
        2、参与的运算   
        3、表示的数据范围  
    类型:   
        字符   
        数值:整型、浮点型 

强类型:变量不经过强制转换,它永远是这个数据类型,不允许隐式的类型转换。
        一般定义变量时必须指定类型、参与运算必须符合类型要求;
        调用未声明 变量会产生错误        
            如   java,c# 

弱类型:语言的运行时会隐式做数据类型转换。无须指定类型,
        默认均为字符型;参与运算会自动进行隐式类型转换;
        变量无须事先定义可直接调用  
            如:bash 不支持浮点数,php 

变量命名法则:  
    1、不能使程序中的保留字:
        例如if, for  
    2、只能使用数字、字母及下划线,且不能以数字开头  
    3、见名知义  
    4、统一命名规则:驼峰命名法 

变量的种类
    根据变量的生效范围等标准划分下面变量类型:  
        局部变量:生效范围为当前shell进程;对当前shell之外的其它shell进程,
        包括 当前shell的子shell进程均无效  
    环境(全局)变量:生效范围为当前shell进程及其子进程  
    本地变量:生效范围为当前shell进程中某代码片断,通常指函数  
    位置变量:$1, $2, ...来表示,用于让脚本在脚本代码中调用通过命令行传递给它的参数  
    特殊变量:$?, $0, $*, $@, $#,$$ 

局部变量 
    变量赋值:name=‘value’  
    可以使用引用value:  

  (1) 可以是直接字串; name=“root"
  (2) 变量引用:name="$USER"
  (3) 命令引用:name=COMMAND name=$(COMMAND)
  变量引用:${name} $name "":
  弱引用,其中的变量引用会被替换为变量值 '':
  强引用,其中的变量引用不会被替换为变量值,而保持原字符串
  显示已定义的所有变量:set
  删除变量:unset name

环境变量 
变量声明、赋值:  
        export name=VALUE  
        declare -x name=VALUE 
    变量引用:$name, ${name} 
    显示所有环境变量:  
        env  
        printenv  
        export  
        declare -x 
    删除变量:  
        unset name 

bash内建的环境变量: 
    PATH 
    SHELL 
    USER 
    UID 
    HOME 
    PWD 
    SHLVL 
    LANG 
    MAIL 
    HOSTNAME 
    HISTSIZE 
    — 

只读变量:
    只能声明,但不能修改和删除 
    声明只读变量:  
        readonly name  
        declare -r name  
    查看只读变量:  readonly –p   

位置变量:
    在脚本代码中调用通过命令行传递给脚本的参数  
        $1, $2, ...:对应第1、第2等参数,shift [n]换位置  
        $0: 命令本身  
        $*: 传递给脚本的所有参数,全部参数合为一个字符串  
        $@: 传递给脚本的所有参数,每个参数为独立字符串  
        $#: 传递给脚本的参数的个数   
        $@ $* 只在被双引号包起来的时候才会有差异  
        set -- 清空所有位置变量 

进程使用退出状态来报告成功或失败  
    0  代表成功,1-255代表失败  
    $? 变量保存最近的命令退出状态 
    例如: 
        ping -c1 -W1 hostdown &> /dev/null  
        echo $?

bash自定义退出状态码   
    exit [n]:自定义退出状态码   
    注意:脚本中一旦遇到exit命令,脚本会立即终止;终止退出状态取决于exit命 
        令后面的数字   
    注意:如果未给脚本指定退出状态码,
            整个脚本的退出状态码取决于脚本中执行的最后一条命令的状态码 
    bash中的算术运算:help let  
        +, -, *, /, %取模(取余), **(乘方)  
        实现算术运算:  
            (1) let var=算术表达式  
            (2) var=$[算术表达式]  
            (3) var=$((算术表达式))  
            (4) var=$(expr arg1 arg2 arg3 ...)  
            (5) declare –i var = 数值  
            (6) echo ‘算术表达式’ | bc  
        乘法符号有些场景中需要转义,如* 
        bash有内建的随机数生成器:$RANDOM(0-32767)  
            echo $[$RANDOM%50] :0-49之间随机数

增强型赋值:  
    +=, -=, *=, /=, %= 
    let varOPERvalue  
        例如:let count+=3       
            自加3后自赋值 
    自增,自减:  
        let var+=1  
        let var++  
        let var-=1  
        let var-- 

    true, false  
        1, 0 
    与:  
        1 与 1 = 1  
        1 与 0 = 0  
        0 与 1 = 0  
        0 与 0 = 0 
    或:  
        1 或 1 = 1   
        1 或 0 = 1  
        0 或 1 = 1  
        0 或 0 = 0

    非:!  
        ! 1 = 0  
        ! 0 = 1 
    短路运算    
    短路与  
        第一个为0,结果必定为0  
        第一个为1,第二个必须要参与运算    
    短路或  
        第一个为1,结果必定为1  
        第一个为0,第二个必须要参与运算 
    异或:^        
        异或的两个值,相同为假,不同为真 

判断某需求是否满足,需要由测试机制来实现   
专用的测试表达式需要由测试命令辅助完成测试过程 
评估布尔声明,以便用在条件性执行中  
    若真,则返回0 
    若假,则返回1 
测试命令: 
    test EXPRESSION 
    [ EXPRESSION ] 
    [[ EXPRESSION ]]       
    注意:EXPRESSION前后必须有空白字符 

根据退出状态而定,命令可以有条件地运行 
    && 代表条件性的AND  THEN 
    ||  代表条件性的OR  ELSE 

    例如: 
        grep -q no_such_user /etc/passwd \ 
        || echo 'No such user'  
        No such user 
        ping -c1 -W2 station1 &> /dev/null  \  
        >    && echo "station1 is up"         \  
        >    || (echo 'station1 is unreachable'; exit 1)  
        station1 is up 

test命令
    长格式的例子:  
        test "$A" ==  "$B" && echo "Strings are equal"   
        test “$A” -eq “$B” && echo "Integers are equal"  
    简写格式的例子: 
        [ "$A" ==  "$B" ] && echo "Strings are equal"  
        [ "$A" -eq "$B" ] && echo "Integers are equal" 

bash数值测试
    -v VAR       
        变量VAR是否设置 
    数值测试:  
        -gt 是否大于  
        -ge 是否大于等于  
        -eq 是否等于  
        -ne 是否不等于  
        -lt 是否小于  
        -le 是否小于等于 

bash的字符串测试

    字符串测试:  
        == 是否等于  
        > ascii码是否大于ascii码  
        < 是否小于  
        != 是否不等于  
        =~ 左侧字符串是否能够被右侧的PATTERN所匹配         
            注意: 此表达式一般用于[[  ]]中;扩展的正则表达式    
            -z "STRING“ 字符串是否为空,空为真,不空为假    
            -n "STRING“ 字符串是否不空,不空为真,空为假   
        注意:用于字符串比较时的用到的操作数都应该使用引号 

存在性测试  
    -a FILE:同-e  
    -e FILE: 文件存在性测试,存在为真,否则为假 
存在性及类别测试  
    -b FILE:是否存在且为块设备文件  
    -c FILE:是否存在且为字符设备文件  
    -d FILE:是否存在且为目录文件  
    -f FILE:是否存在且为普通文件  
    -h FILE 或 -L FILE:存在且为符号链接文件  
    -p FILE:是否存在且为命名管道文件  
    -S FILE:是否存在且为套接字文件 

文件权限测试:  
    -r FILE:是否存在且可读  
    -w FILE: 是否存在且可写  
    -x FILE: 是否存在且可执行 

文件特殊权限测试:  
    -u FILE:是否存在且拥有suid权限  
    -g FILE:是否存在且拥有sgid权限  
    -k FILE:是否存在且拥有sticky权限 

bash文件的属性测试
    文件大小测试:  
        -s FILE: 是否存在且非空 
    文件是否打开:  
        -t fd: fd  文件描述符是否在某终端已经打开  
        -N FILE:文件自从上一次被读取之后是否被修改过  
        -O FILE:当前有效用户是否为文件属主  
        -G FILE:当前有效用户是否为文件属组 

    双目测试:  
        FILE1 -ef FILE2: FILE1是否是FILE2的硬链接  
        FILE1 -nt FILE2: FILE1是否新于FILE2(mtime)  
        FILE1 -ot FILE2: FILE1是否旧于FILE2 
bash的组合测试条件
    第一种方式:  
        COMMAND1 && COMMAND2 并且  
        COMMAND1 || COMMAND2 或者  
        ! COMMAND   非  
            如:[[ -r FILE ]] && [[ -w FILE ]] 

    第二种方式:  
        EXPRESSION1 -a EXPRESSION2 并且  
        EXPRESSION1 -o EXPRESSION2 或者  
        ! EXPRESSION     必须使用测试命令进行 

  示例: [ -z “$HOSTNAME” -o $HOSTNAME "==\
      "localhost.localdomain" ] && hostname www.xxx.com
      [ -f /bin/cat -a -x /bin/cat ] && cat /etc/fstab

使用read命令来接受输入
    使用read来把输入值分配给一个或多个shell变量 
        -p 指定要显示的提示 
        -s   静默输入,一般用于密码 
        -n  N 指定输入的字符长度N 
        -d ‘字符’  输入结束符 
        -t  N  TIMEOUT为N秒 
        read 从标准输入中读取值,给每个单词分配一个变量 
        所有剩余单词都被分配给最后一个变量 
        read -p “Enter a filename: “ FILE 

bash展开命令行
    把命令行分成单个命令词 
    展开别名 
    展开大括号的声明({}) 
    展开波浪符声明(~) 
    命令替换$() 和 ``) 
    再次把命令行分成命令词 
    展开文件通配(*、?、[abc]等等) 
    准备I/0重导向(<、>) 
    运行命令 

防止拓展
    反斜线(\)会使随后的字符按原意解释 
        $ echo Your cost: \$6.00  
        Your cost: $6.00 
    加引号来防止扩展 
        单引号(’)防止所有扩展  
        双引号(”)也防止所有扩展,但是以下情况例外: 
            $(美元符号) - 变量扩展 
            `(反引号) - 命令替换 
            \(反斜线) - 禁止单个字符扩展 
            !(叹号) - 历史命令替换 

bash的配置文件
    按照生效范围可以分为2类:

    全局配置:
        /etc/profile
        /etc/profile.d/*.sh
        /etc/bashrc
    个人配置文件
        ~/.bash_profile
        ~/.bashrc

shell登录的2种方式
    交互式登录:   
        (1)直接通过终端输入账号密码登录   
        (2)使用“su - UserName” 切换的用户  
        执行顺序:/etc/profile --> /etc/profile.d/*.sh --> ~/.bash_profile --> 
            ~/.bashrc --> /etc/bashrc 

    非交互式登录:   
        (1)su UserName   
        (2)图形界面下打开的终端   
        (3)执行脚本   
        (4)任何其它的bash实例  
    执行顺序: ~/.bashrc --> /etc/bashrc --> /etc/profile.d/*.sh     

Profile类
    按照功能划分,存在两类:
        profile类和bashrc类

    profile类:为交互式登录的shell提供配置
        全局:/etc/profile, /etc/profile.d/*.sh
        个人:~/.bash_profile
        功用:
            1.用于定义环境变量
            2.运行脚本或命令

Bashrc类
    bashrc类:为非交互式和交互式登录的shell提供配置
        全局: /etc/bashrc
        个人:~/.bashrc
        功用: 
            1.定义命令别名和函数
            2.定义本地变量

编辑配置文件生效
    修改profile和bashrc文件后需要生效
        两种方法
            1重启shell进程
            2.或source
            ps 
                .~/.bashrc

bash退出任务
    保存在~/.bash_logout文件中(用户)
    在退出登录shell时候运行
        用于:
            创建自动备份
            清除临时文件

$变量:
    h:hashall,打开这个选项后,Shell 会将命令所在的路径hash下来,避免每次 都要查询。
        通过set +h将h选项关闭 
    i:interactive-comments,包含这个选项说明当前的 shell 是一个交互式的 shell。
        所谓的交互式shell,在脚本中,i选项是关闭的。 
    m:monitor,打开监控模式,就可以通过Job control来控制进程的停止、继续,
        后台或者前台执行等。 
    B:braceexpand,大括号扩展 
    H:history,H选项打开,可以展开历史列表中的命令,可以通过!感叹号来完 成,
        例如“!!”返回上最近的一个历史命令,“!n”返回第 n 个历史命令 

bash -x调试执行时候,显示前面的+的数量表示语句嵌套的深度
输出文章时候,可以使用“”来保持其格式
pstrss -p 查看所有父子进程树
echo $$ 显示当前的进程编号
局部变量工作范围:当前进程,无法跨进程和session,无法向子进程和父进程传递
全局变量可以可以向下传递,无法向上传递
env命令可以显示环境变量
set可以显示所有变量和函数
$BASHPID 子进程ID
$PPID   父进程ID
readonly 只读常量,无法unset删除,但是它随着当前shell的结束而释放
    -p 可以显示常量
declare -r 也可以显示常量
单独使用一次(一次性)可以通过()通过对子进程shell影响,退出子进程之后修改无效
    ps :(umask 666; touch /data/f1 此时这个文件是000权限,但是父shell不影响)
{ command }  则是会影响当前shell的,不会开启子shell

ps:
    x=1;echo $$;(echo $$;echo $x;x=2;echo $x);echo $x
    1323
    1323
    1
    2   
    1
()和真正的子shell有一定不同,()相当于开启了一个子shell但是并不是真正开启

参数超过9则${}
    ps: 10以上参数 #{10}

脚本中set --清空参数

建立软连接可以改变$0的显示

$?的0或非0只是与最后一条有关,最后一条成功则$0为0,若存在语法错误,则需要自学查看错误来源
通过exit +数字可以修改返回数字

$_显示最后一个参数
小括号用法:
    括号内的命令执行不影响当前shell,用于一次性任务
    {}不开启子shell会影响当前shell 环境
shift命令:可以实现参数的队列排出
    脚本中 shift 12345->2345
            shift 2 12345->345

expr 加算数运算
    ps: expr 3 \* 2(中间加空格表示参数 *号要转义)
        expr 1 + 2 做加法运算

    a b异或互换
        a=$[a^b] 获取中间值
        b=$[a^b] b获取原来的a
        a=$[a^b] a获取原来的b
    echo $a $b完成互换

    true    单纯返回正确结果
        ps: trus 
            $?
            0
    false   单纯返回错误结果
        ps:false
            $?
            1
    中括号内使用变量时候通常建议加“”避免空字符的影响

    false || {echo cmd1 ; echo cmd2; } 若为false则执行cmd1和cmd2 
    false || (cho cmd1 ; echo cmd2; )若为false则执行cmd1和cmd2 

    true || {echo cmd1 ; echo cmd2; } 若为true则不会执行cmd1和cmd2 
    true || (echo cmd1 ; echo cmd2; ) 若为false则不会执行cmd1和cmd2 

    false || {echo cmd1 ; exit; } 在脚本中执行这条语句时候使用{}这样可以实现
        脚本的退出,若使用()则无法退出,()开启了一个新的子shell

    被赋空和空值有区别